//
//  KonohanaDB.m
//  konohana_test
//
//  Created by kunii on 09/11/15.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "KonohanaDB.h"


@implementation KonohanaDB

@synthesize dbDelegate;

/*
	移譲先に投稿発見を通知。
*/
-(void)handleArrivedContribution:(int)inID photo:(UIImage*)photo name:(NSString*)name comment:(NSString*)comment
{
	if ([dbDelegate respondsToSelector:@selector(arrivedContribution:photo:name:comment:)]) {
		[dbDelegate arrivedContribution:inID photo:photo name:name comment:comment];
	}
}

/*
	移譲先に終了を通知。
*/
-(void)handleTerminate
{
	if ([dbDelegate respondsToSelector:@selector(terminate)]) {
		[dbDelegate terminate];
	}
}


//	無条件接続
-(void)connect
{
	int userID = 1;
	UIImage* photo = [UIImage imageNamed:@"dummy.png"];
	NSString* name = @"名前";
	NSString* comment = @"コメント";
	for (int i = 0; i < 5; i++) {
		[self handleArrivedContribution:userID photo:photo 
			name:[NSString stringWithFormat:@"%@ %d", name, i + 1]
			comment:[NSString stringWithFormat:@"%@ %d", comment, i + 1]];
	}
	[photo release];
	[self handleTerminate];
}

//	投稿者ID付き接続、投稿者IDの一致する投稿をリストアップ
-(void)connectWithUserID:(int)inUserID
{
	[self connect];
}

//	投稿者ID付き接続、投稿者IDの一致する提案をもつ投稿をリストアップ
-(void)connectWithUserIDToSuggest:(int)inUserID
{
	[self connect];
}

@end
